/*
 * jabak Java Backup
 * 
 * Copyright (C) under the terms of the GNU General Public License
 * as explained in the file "disclaimer.txt"
 */

package backup;

import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.File;
import java.io.FileReader;
import java.io.FileWriter;
import java.util.Enumeration;

/**
 * @author  Georg Dietrich
 * @version 1.0 on 2004-04-09
 */
public class BackupFile {

	public static void scan (Settings settings) {
		File source = new File (settings.dataRootPath+File.separator+".backup");
		if (source.exists()) {
			try {
				BufferedReader reader = new BufferedReader(new FileReader(source));
				
				// parse type of backup being continued
				settings.backupContinued = Util.parseInt(reader.readLine());
				
				// parse all earlier backups being continued
				for (String line = reader.readLine(); line != null; line = reader.readLine()) {
					settings.earlierBackups.add(line);
				}

				reader.close();
			} catch (Exception e) {
				System.err.println("check status gescheitert fr "+source);
				e.printStackTrace();
				throw new RuntimeException();
			}
		}
	}
	
	public static void remove (Settings settings) {
		File source = new File (settings.dataRootPath+File.separator+".backup");
		if (source.exists()) source.delete();
	}

	public static void update (Settings settings) {
		File dest = new File (settings.dataRootPath+File.separator+".backup");
		
		try {
			BufferedWriter writer = new BufferedWriter(new FileWriter(dest));

			writer.write(settings.backupType+""); writer.newLine();
			for (Enumeration e = settings.earlierBackups.elements(); e.hasMoreElements(); ){
				writer.write((String)e.nextElement()); writer.newLine();
			}
			writer.write(settings.backupTime);

			writer.close();
		} catch (Exception e) {
			System.err.println("save data file gescheitert fr "+dest);
			e.printStackTrace();
			throw new RuntimeException();
		}

		
	}
}
