/*
 * jabak Java Backup
 * 
 * Copyright (C) under the terms of the GNU General Public License
 * as explained in the file "disclaimer.txt"
 */

package backup;

import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.File;
import java.io.FileReader;
import java.io.FileWriter;

/**
 * @author  Georg Dietrich
 * @version 1.0 on 2004-04-09
 */
public class DataFile {

	protected File file;
	public int    incHash, difHash, fulHash;
	public String incDate, difDate, fulDate;
	
	public DataFile (File data) {
		file = data;
		if (data.exists()) {
			try {
				BufferedReader reader = new BufferedReader(new FileReader(data));
				
				if (!reader.readLine().equals("gb_1.0")) { 
					System.err.println("conflicting versions in data file "+data);
					System.err.println("remove all data files and try again.");
					throw new RuntimeException();
				}
				incHash = Util.parseInt(reader.readLine());
				incDate = reader.readLine();
				difHash = Util.parseInt(reader.readLine());
				difDate = reader.readLine();
				fulHash = Util.parseInt(reader.readLine());
				fulDate = reader.readLine();

				reader.close();
			} catch (Exception e) {
				System.err.println("check status gescheitert fr "+data);
				e.printStackTrace();
				throw new RuntimeException();
			}
		}
	}

	public void save () {
		Util.makeDirs(file);
		try {

			BufferedWriter writer = new BufferedWriter(new FileWriter(file));
			writer.write("gb_1.0"); writer.newLine();
			writer.write(incHash+""); writer.newLine();
			writer.write(incDate+""); writer.newLine();
			writer.write(difHash+""); writer.newLine();
			writer.write(difDate+""); writer.newLine();
			writer.write(fulHash+""); writer.newLine();
			writer.write(fulDate+""); writer.newLine();
			writer.close();

		} catch (Exception e) {
			System.err.println("save data file gescheitert fr "+file);
			e.printStackTrace();
			throw new RuntimeException();
		}
	}
	
	public void remove () {
		if (file.exists()) file.delete();
	}

}
