/*
 * jabak Java Backup
 * 
 * Copyright (C) under the terms of the GNU General Public License
 * as explained in the file "disclaimer.txt"
 */

package backup;

import java.util.Vector;

/**
 * @author  Georg Dietrich
 * @version 1.2 on 2004-04-18
 * @version 1.1 on 2004-04-10
 * @version 1.0 on 2004-04-09
 */
public class Settings {

	public Vector filter = new Vector();
	public boolean filterOut = true;

	/** vector of backup time stamps the current backup process is dependent of */
	public Vector  dependencies;

	/** the canonical paths belonging to the backup file references */
	public String  sourceRootPath,   backupRootPath,   dataRootPath;

	/** the size in bytes to use (approx) for one backup */
	public long    backupSize;

	/** the time (as string) when backup started, to be used in backup path */
	public String  backupTime = Util.getTimeString();

	/** the type of backup to perform: 1/2/3 incremental/differential/full */
	public int     backupType = 0;

	/** the current size of the backup in bytes */
	public long    currentSize = 0;

	/** flag whether all data could be backuped within the limits of the backup size */
	public boolean backupFinished  = true;

	/** flag which kind of backup this is a continuation of */
	public int     backupContinued = 0;

	/** vector of all backup time stamps this is a continuation of */
	public Vector  earlierBackups  = new Vector();	

	/** counter for files backed up */
	public int filesBackedUp = 0;
	
	/** counter for files skipped because they are already backed up */
	public int filesSkipped = 0;
	
}
